//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.AuthorizationProvider;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Auth.AuthorizationProviderService
{
    
    
    /// <summary>
    /// A class that exposes the IAuthorizationProviderService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AuthorizationProviderServiceProvider : IFeatureProvider
    {
        
        private IAuthorizationProviderService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(AuthorizationProviderServiceProvider).Assembly, "AuthorizationProviderService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public AuthorizationProviderServiceProvider(IAuthorizationProviderService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<VerifyRequestDto, VerifyResponseDto>("Verify", Verify);
        }
        
        /// <summary>
        /// Executes the Verify command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual VerifyResponseDto Verify(VerifyRequestDto request)
        {
            try
            {
                request.Validate();
                return new VerifyResponseDto(_implementation.Verify(request.AccessToken.TryExtract(_server, "org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Ac" +
                                "cessToken"), request.RequestedServer.TryExtract(_server, "org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Re" +
                                "questedServer"), request.RequestedFeature.TryExtract(_server, "org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Re" +
                                "questedFeature")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "accessToken"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Ac" +
                            "cessToken", ex.Message);
                }
                if ((ex.ParamName == "requestedServer"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Re" +
                            "questedServer", ex.Message);
                }
                if ((ex.ParamName == "requestedFeature"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthorizationProviderService/v1/Command/Verify/Parameter/Re" +
                            "questedFeature", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (AuthorizationFailedException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/AuthorizationProviderService/v1/DefinedExecutionError/Autho" +
                        "rizationFailed", "", ex.Message);
            } catch (InvalidAccessTokenException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/AuthorizationProviderService/v1/DefinedExecutionError/Inval" +
                        "idAccessToken", "", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/core/AuthorizationProviderService/v1/Command/Verify"))
            {
                return typeof(IAuthorizationProviderService).GetMethod("Verify");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}


